//
//	da6809.h
//

#ifndef __da6809_h__
#define __da6809_h__

#include <stdlib.h>
#include "e2global.h"
#include "e2video.h"

class Da6809 {


protected:

	char    	code_buf[28];		// buffer for machinecode
	char    	mnem_buf[28];		// buffer for mnemonic
	Memory*    	memory;			// object-pointer to memory

public:
			Da6809(Memory* memory);// public constructor
	virtual		~Da6809();		// public destructor

	virtual int	disassemble(unsigned int address, int *pstep,
				char **pb1, char **pb2);

private:

	int 		D_Page10   (unsigned int);
	int 		D_Page11   (unsigned int);
	int 		D_Illegal  (char *, int, unsigned int);
	int 		D_Direct   (char *, int, unsigned int);
	int 		D_Immediat (char *, int, unsigned int);
	int 		D_ImmediatL(char *, int, unsigned int);
	int 		D_Inherent (char *, int, unsigned int);
	int 		D_Indexed  (char *, int, unsigned int);
	int 		D_Extended (char *, int, unsigned int);
	int 		D_Relative (char *, int, unsigned int);
	int 		D_RelativeL(char *, int, unsigned int);
	int 		D_Register0(char *, int, unsigned int);
	int 		D_Register1(char *, int, unsigned int);
	int 		D_Register2(char *, int, unsigned int);

	char  		*IndexedRegister(int which);
	char  		*InterRegister(int which);
	char  		*StackRegister(int which, char *not_stack);
};  // class Da6809

#endif // __da6809_h__

