/*
    e2video.cc


    flexemu, an MC6809 emulator running FLEX
    Copyright (C) 1997  W. Schwotzer

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

    woschwot@si.bosch.de
*/



#include "e2.h"
#include "e2video.h"

E2video::E2video(void)
{
	reset();
} 

E2video::~E2video()
{
}


void E2video::reset()
{
	vico1            = 0;
	vico2            = 0;
	divided_block	 = -1;
	blocks_to_update = 0;
}

void E2video::init_blocks_to_update(void)
{
	blocks_to_update = YBLOCKS;
}

int E2video::are_blocks_to_update(void)
{
	if (blocks_to_update <= 0)
		return 0;
	else {
		blocks_to_update--;
		return 1;
	}
}


// if bit 1 of vico1 is set, no video ram is selected and all one's is
// displayed on the window like on the real Eurocom II

void E2video::write_co(Word offset, Byte val)
{

	if (offset == VICO_BASE) {
		vico1 = val & 0x03;
		init_blocks_to_update();
	} else {
		vico2 = val;
		init_blocks_to_update();
		if (YBLOCKS != 1 && vico2 % BLOCKHEIGHT)
			divided_block = vico2 / BLOCKHEIGHT;
		else
			divided_block = -1;  // means: no such block
	} // else
}

