/*
    inout.h


    flexemu, an MC6809 emulator running FLEX
    Copyright (C) 1997  W. Schwotzer

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

    woschwot@si.bosch.de
*/



#ifndef __inout_h__
#define __inout_h__

#include "misc.h"


#define KEY_BUFFER_SIZE 8

class Inout {

// Internal registers

private:
	int	key_buffer[KEY_BUFFER_SIZE];
	int	in, out;
	int	bell_request, percent;

// pointer interface
public:
	int	deltaX, deltaY;
	unsigned int buttonMask;

// public interface

public:
	void	reset(void);
	int	poll(void);
	Byte	read_ch(void);
	void	put_ch(int key);
	int	key_buffer_full(void);
	void	set_bell(int x_percent);
	int	is_bell_request(int *x_percent);

// Public constructor and destructor
public:
		Inout(void);
		~Inout();

};

#endif // __inout_h__

