/*
    mc146818.h


    flexemu, an MC6809 emulator running FLEX
    Copyright (C) 1997  W. Schwotzer

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

    woschwot@si.bosch.de
*/



#ifndef __mc146818_h__
#define __mc146818_h__

#include "misc.h"
#include "mc6809.h"


#define RAM_SIZE 50 			// size of internal ram


class Mc146818 {

// Internal registers:
//

protected:

	Byte				A, B, C, D;
	Byte				ram[RAM_SIZE];
	Mc6809*				cpu;

public:

	virtual Byte			 read(Word offset);
	virtual void			 write(Word offset, Byte val);
	virtual void			 reset(void);
	virtual void			 update_1_second(void);

private:

	Byte			 	convert(Byte val);
	Byte			 	convert_hour(Byte val);

// Public constructor and destructor

public:

					 Mc146818(Mc6809* x_cpu);
	virtual				~Mc146818();

};

#endif // __mc146818_h__

