/*
    misc.cc


    flexemu, an MC6809 emulator running FLEX
    Copyright (C) 1997  W. Schwotzer

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

    woschwot@si.bosch.de
*/



#include <ctype.h>
#include "mc6809.h"

void strupper(char *pstr)
{
	while (*pstr)
		*(pstr++) = toupper(*pstr);
} // strupper


void strlower(char *pstr)
{
	while (*pstr)
		*(pstr++) = tolower(*pstr);
} // strlower

// Bit extend operations
Word extend8(Byte x)
{
	if (x & 0x80) {
		return (Word)x | 0xff00;
	} else {
		return (Word)x;
	}
}

// Base 2 and Base 16 conversion functions
char *binstr(Byte x)
{
	static char		tmp[9] = "        ";

	for (int i = 7; i >= 0; --i) {
		tmp[i] = (x & 1) + '0';
		x >>= 1;
	}

	return tmp;
}

static char hex_digit(Byte x)
{
	x &= 0x0f;
	if (x <= 9) {
		return '0' + x;
	} else {
		return 'a' + x - 10;
	}
}

char *hexstr(Byte x)
{
	static char		tmp[3] = "  ";

	tmp[1] = hex_digit(x);	x >>= 4;
	tmp[0] = hex_digit(x);

	return tmp;
}

char *hexstr(Word x)
{
	static char		tmp[5] = "    ";

	tmp[3] = hex_digit(x);	x >>= 4;
	tmp[2] = hex_digit(x);	x >>= 4;
	tmp[1] = hex_digit(x);	x >>= 4;
	tmp[0] = hex_digit(x);

	return tmp;
}

char *ascchr(Byte x)
{
	static char		tmp[2] = " ";

	x &= 0x7f;
	tmp[0] = ((x >= 0x20) && (x < 0x7f)) ? x : '.';

	return tmp;
}
